unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, Buttons, StdCtrls, Menus, ExtCtrls, ComCtrls, NMSTRM, Psock,contnrs;

type
  TclientForm = class(TForm)
    MainMenu1: TMainMenu;
    UserListBox: TListBox;
    Edit1: TEdit;
    Panel1: TPanel;
    Verbinden1: TMenuItem;
    Verbinden2: TMenuItem;
    Verbindungtrennen1: TMenuItem;
    Extras1: TMenuItem;
    Einstellungen1: TMenuItem;
    Label1: TLabel;
    sendenButton: TButton;
    connectBitBtn: TBitBtn;
    disconnectBitBtn: TBitBtn;
    privatchatBitBtn: TBitBtn;
    flstern1: TMenuItem;
    ClientSocket: TClientSocket;
    Label2: TLabel;
    Label3: TLabel;
    ColorDialog1: TColorDialog;
    farbeBitBtn: TBitBtn;
    exitBitBtn: TBitBtn;
    RichEdit1: TRichEdit;
    Label4: TLabel;
    Label5: TLabel;
    N1: TMenuItem;
    Hilfe2: TMenuItem;
    Credits2: TMenuItem;
    Farbe1: TMenuItem;
    Beenden1: TMenuItem;
    privatChat1: TMenuItem;
    pchatBitBtn: TBitBtn;
    Suche1: TMenuItem;
    sentfileBitBtn: TBitBtn;
    NMStrmServ: TNMStrmServ;
    NMStrm: TNMStrm;
    SaveDialog1: TSaveDialog;
    ProgressBar1: TProgressBar;
    Label6: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Verbinden2Click(Sender: TObject);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure disconnectBitBtnClick(Sender: TObject);
    procedure sendenButtonClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure connectBitBtnClick(Sender: TObject);
    procedure farbeBitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure exitBitBtnClick(Sender: TObject);
    procedure ClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure privatchatBitBtnClick(Sender: TObject);
    procedure Farbe1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure pchatBitBtnClick(Sender: TObject);
    procedure Suche1Click(Sender: TObject);
    procedure Einstellungen1Click(Sender: TObject);
    procedure flstern1Click(Sender: TObject);
    procedure sentfileBitBtnClick(Sender: TObject);
    procedure NMStrmConnect(Sender: TObject);
    procedure NMStrmConnectionFailed(Sender: TObject);
    procedure NMStrmMessageSent(Sender: TObject);
    procedure NMStrmPacketSent(Sender: TObject);
    procedure NMStrmServClientContact(Sender: TObject);
    procedure NMStrmServMSG(Sender: TComponent; const sFrom: String;
      strm: TStream);
    procedure NMStrmServConnect(Sender: TObject);
    procedure UserListBoxDblClick(Sender: TObject);
    procedure NMStrmServConnectionFailed(Sender: TObject);
    procedure Hilfe2Click(Sender: TObject);
    procedure Credits2Click(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure onsendenclick(Sender: TObject);
    procedure schliessen(Sender: TObject; var Action: TCloseAction);
    procedure EditprivatKeyPress(Sender: TObject; var Key: Char);


  public
    { Public-Deklarationen }
  end;

var
  clientForm: TclientForm;
  myform    : Tobject;

{-------------allgemeine Records---------------- }
TYPE
   T_user= RECORD
               ip                : string;
               name              : string;
             END;
   T_users = Array[0..100] of T_user;

{-------------allgemeine Variablen---------------- }
var
   server,bname,ext             :string;
   user                         :T_users;
   sentfile                     :integer;
   formlist                     :Tobjectlist;

   type
  TTest = class
    sText: String;
  end;


implementation

uses Unit1, Unit3,ShellAPI, Unit4, Unit5, Unit6, Unit7;


{$R *.DFM}
var
   farbe, anzahluser,privatchats:integer;
   verbunden                    :boolean;

   mtdbtn,mtdform               : TMethod;
   test,datei                   : string;
//   TMeinFormular66              : TPersistentClass;


{----------------------------------eigene Proceduren----------------------}

procedure zeigen;
begin
 showmessage('info:'+ ext);
end;


procedure Tclientform.schliessen(Sender: TObject; var Action: TCloseAction);
begin
     FormList.Remove((Sender as TForm));
end;

procedure Tclientform.onsendenclick(Sender: TObject);
var nachricht, nach : string;
begin
     nachricht:=((Sender as Tbutton).owner.Components[2]as TEdit).text; //greift auf den Text des dynamischen Editfeldes zu
     nach:=(Sender as Tbutton).owner.name;  //holt den Benutzernamen zu dem der Text geschickt wird
     ClientSocket.Socket.SendText('$#pchat:'+ nach + ':' + bname + '#' + nachricht);
     ((Sender as Tbutton).owner.Components[1]as TRichEdit).lines.add(bname + ': ' + nachricht);
//     showmessage('$#pchat:'+ nach + ':' + bname + '#' + nachricht);
end;

procedure TclientForm.EditprivatKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
    begin
    ((Sender as Tedit).owner.Components[3]as TButton).click;     //lt sendenfunktion vom dynamischen Button aus
       (sender as TEdit).text:='';
    end;
end;

procedure privatchat(chatuser : string);
var
   NForm: array[1..100] of TForm;      //erlaubt 99 Chatfenster
   i : integer;
   existiert : boolean;

begin
existiert:=false;
i:=0;
if Formlist.Count <> 0 then                                       //prft ob das Fenster schon existiert
    repeat
          if (formlist.Items[i] as TForm).name=chatuser then
          begin
               (formlist.Items[i] as TForm).show;
               existiert:=true;
               i:=formlist.count;
          end;
          inc(i);
    until i >= formlist.count;

if existiert=false then           //erstellt Formular
   begin
     i:=0;
     inc(i);
     NForm[i]:=TForm.create(clientForm);
     Formlist.Add(NForm[i]);
     NForm[i].show;
     NForm[i].width:=300;
     NForm[i].height:=270;
     NForm[i].name:=chatuser;
     NForm[i].top:=i*10;
     NForm[i].left:=i*10;
     NForm[i].onclose:=clientform.schliessen;

     with Tlabel.Create(NForm[i]) do
     begin
          parent := NForm[i];
          name:='chatuserlabel';
          caption:='Chat mit '+ chatuser + ' :';
          width:=280;
          height:=20;
          left:=5;
          top:=5;
     end;

     with Trichedit.Create(NForm[i]) do
     begin
          parent := NForm[i];
          name:='richeditprivat';
          width:=280;
          height:=170;
          left:=5;
          top:=30;
          clear;
     end;

     with Tedit.Create(NForm[i]) do
     begin
          parent := NForm[i];
          name:='editprivat';
          text := 'text';
          width:=200;
          left:=5;
          top:=210;
          setfocus;
          onkeypress:=Clientform.EditprivatKeyPress;
     end;

     with Tbutton.Create(NForm[i]) do
     begin
          parent := NForm[i];
          name:='sendenprivatbutton';
          caption := 'senden';
          top:=210;
          left:=210;
          height:=23;
          Onclick:=clientform.onsendenclick;
     end;
end {if};
end;

{------------------------------------Ende eigener Proceduren--------------}

procedure TclientForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 disconnectbitbtn.Click;
 auswahlform.close;
end;

procedure TclientForm.Verbinden2Click(Sender: TObject);
begin

  ClientSocket.close;
  if InputQuery('Verbindung aufbauen zu:', 'Computer IP/Name:', Server) then
    if Length(Server) > 0 then
     if InputQuery('Benutername', 'Benutername (Max. 14 Zeichen):', bname) then
      if length(bname) > 0 then
      begin
           bname:=copy(bname,0,14);  // Benutzername darf nur 14 Zeichenhaben
           label5.caption:=bname;
           ClientSocket.Port :=port; // es ist nicht mglich mit with clientsocket do zu arbeiten, da variable auch port heit
           ClientSocket.Host := Server;
           Clientsocket.open;
           edit1.SetFocus;
           //ClientSocket.Socket.SendText('$#neu:'+ bname + ':' + inttostr(farbe) + ':' + + '#' + edit1.text);
      end;
end;

procedure TclientForm.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  label3.caption :=Socket.RemoteHost;
  ClientSocket.Socket.SendText('$#neu:'+ bname + ':' + inttostr(farbe) + ':' + socket.LocalAddress + '#');
  richedit1.lines.Add('Verbindung hergestellt');
end;

procedure TclientForm.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
// if suche=false then showmessage('suche false');
// if suche=true then showmessage('suche true');
  richedit1.Lines.Add('Fehler beim Verbinden mit: ' + label3.caption);
  ErrorCode := 0;
end;

procedure TclientForm.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
   nachricht,befehl,temp,
   tempname,tempip                 :string;
   farbe                           :integer;
   senden, gefunden                :boolean;

procedure befehlauswerten(ueb:string);
var i        : integer;
    mystream : TStream;
    nachricht: string;
begin
 befehl:=copy(ueb,0,pos(':', ueb)-1);   //kopiert ersten befehl heraus

 if befehl='farbe' then farbe:=strtoint(copy(ueb,pos(':', ueb)+1,pos('#', ueb)-pos(':', ueb)-1));

 if befehl='pmassage' then
 begin
    farbe:=clblue;
    Richedit1.SelAttributes.Color:=farbe;
    Richedit1.Lines.add('Private Nachricht von: ' + copy(ueb,pos(':', ueb)+1,pos('#', ueb)-pos(':', ueb)-1));
 end;

 if befehl='pchat' then
 begin
    temp:=copy(ueb,pos(':', ueb)+1,pos('#', ueb)-pos(':', ueb)); //entfernt ersten Befehl
    temp:=copy(temp,pos(':', temp) + 1,pos('#', temp)-pos(':', temp)-1);             //kopiert Benutzername von wem die Nachricht geschickt wurde heraus
    nachricht:=copy(ueb,pos('#',ueb)+1,length(ueb));
//    i:=0;
//    for i:=0 to Formlist.Count-1 do showmessage((Formlist.Items[i] as TForm).name);
    i:=0;
    gefunden:=false;
    if Formlist.Count <> 0 then
    repeat
          if (formlist.Items[i] as TForm).name=temp then
          begin
               ((Formlist.Items[i] as TForm).components[1] as TRichedit).Lines.add(temp + ': ' + nachricht);
               i:=formlist.count;
               gefunden:=true;
          end;
          inc(i);
    until i >= formlist.count;
    if (Formlist.count = 0) or (gefunden=false) then
        begin
             privatchat(temp);
             ((Formlist.Items[0] as TForm).components[1] as TRichedit).Lines.add(temp + ': ' + nachricht);
        end;
    senden:=false;
 end;

 if befehl='noconnect' then
 begin
      clientsocket.close;
      richedit1.Lines.add('Der Benutzername ist bereits vergeben');
      verbunden:=false;
      senden:=false;
 end;

 if befehl='kill' then
 begin
      clientsocket.close;
      senden:=false;
 end;

 if befehl='file' then
 begin
   temp:=copy(ueb,pos(':', ueb)+1,pos('#', ueb));            //entfernt den Befehl
   tempname:=copy(temp,0,pos(':', temp)-1);                       //kopiert Benutzername heraus
   temp:=copy(temp,pos(':', temp)+1,pos('#', temp));            //kopiert Restbefehl heraus
   tempip:=copy(temp,0,pos(':', temp)-1);                            //kopiert IP heraus
   temp:=copy(temp,pos(':', temp)+1,pos('#', temp));            //kopiert Benutzernameanweisung heraus
   datei:=copy(temp,0,pos('#', temp)-1);                          //kopiert dateinamen heraus
   richedit1.SelAttributes.Color:=clgreen;
   richedit1.Lines.Add('Erhalte Datei "' + datei + '" von ' + tempname);
   if MessageDlg('Erhalte Datei "' + datei + '" von ' + tempname ,mtInformation,[mbOK,mbIgnore],0) = mrIgnore then
     begin
       clientsocket.socket.sendtext('$#fileabgelehnt:'+ tempname + ':' + bname + ':' + datei + '#');
     //Abort
     end
     else
     begin
       ext:=copy(datei,pos('.', datei),length(datei)-pos('\', datei));  //kopiert Dateiendung heraus
       label6.caption:=ext;
       clientsocket.socket.sendtext('$#fileangenommen:'+ tempname + ':' + bname + ':' + datei + '#');
       NMStrmServ.host:=tempip;
     end;
 end;

 if befehl='fileabgelent' then
 begin
   temp:=copy(temp,pos(':', temp)+1,pos('#', temp));            //entfernt den Befehl
   tempname:=copy(ueb,0,pos(':', ueb)-1);                       //kopiert Benutzername heraus
   temp:=copy(temp,pos(':', temp)+1,pos('#', temp));            //kopiert Restbefehl heraus
   temp:=copy(temp,0,pos(':', temp)-1);                            //kopiert Dateinamen heraus
   showmessage('Der User' + tempname + 'hat die Datei ' + temp + ' abgelent!');
 end;

 if befehl='fileangenommen' then
 begin
   temp:=copy(ueb,pos(':', ueb)+1,pos('#', ueb));            //entfernt den Befehl
   tempname:=copy(temp,0,pos(':', temp)-1);                       //kopiert Benutzername heraus
//   showmessage(tempname);
   temp:=copy(temp,pos(':', temp)+1,pos('#', temp));            //kopiert Restbefehl heraus
   tempip:=copy(temp,0,pos(':', temp)-1);                            //kopiert IP heraus
//   showmessage(tempip);
   temp:=copy(temp,pos(':', temp)+1,pos('#', temp));            //kopiert Benutzernameanweisung heraus
   datei:=copy(temp,0,pos('#', temp)-1);                          //kopiert dateinamen heraus
//   showmessage(datei);
   richedit1.SelAttributes.Color:=clgreen;
   richedit1.Lines.Add('Datei "' + datei + '" an ' + tempname + '('+ tempip + ')' + 'geschickt');


//   if fileexists(datei) then showmessage('existiert') else showmessage('existiert nicht');
   clientform.NMStrm.host:=tempip;
   MyStream := TFileStream.Create(datei, fmOpenRead);
   try
      clientform.NMStrm.PostIt(MyStream);
   finally
      MyStream.Free;
   end;
 end;

 if befehl='neu' then
 begin
      i:=-1;
      temp:=copy(ueb,pos(':', ueb)+1,pos('#', ueb));
      userlistbox.Items.Clear;
      while not(pos(':' , temp)=0) do
      begin
           inc(i);                                                  //Anzahl der User
           user[i].name:=copy(temp,0,pos(':' ,temp)-1);             //kopiert Username heraus
           temp:=copy(temp,pos(':' ,temp)+1,pos('#' ,temp));        //kopiert restbefehl heraus
           if pos(':' , temp)=0 then                                //wenn letzter user ausgelesen wird, gibt es nur
                 user[i].ip:=copy(temp,0,pos('#' ,temp)-1)          //noch das # Trennungszeichen, sonst das : Trennungszeichen
           else
                 user[i].ip:=copy(temp,0,pos(':' ,temp)-1);
           temp:=copy(temp,pos(':' ,temp)+1,pos('#' ,temp));        //kopiert restbefehl heraus
      end; {of while}

      anzahluser:=i;

      for i:=0 to anzahluser do
      begin
          userlistbox.items.add(user[i].name + ' (' + user[i].ip + ')');
      end;
      verbunden:=true;
      senden:=false;
 end;
end;

begin
//  ext:='.txt';
  nachricht:=Socket.ReceiveText;
  senden:=true;
  if not(copy(nachricht,0,2)='$#') then
     begin
       befehl:='Error';
       nachricht:='Es ist ein bertragungsfehler aufgetreten';
     end
     else
     begin
       nachricht:=copy(nachricht,3,length(nachricht));
       befehlauswerten(nachricht);
       if senden then
        begin
             nachricht:=copy(nachricht,pos('#',nachricht)+1,length(nachricht)-pos('#',nachricht));
             richedit1.SelAttributes.Color:=farbe;
             richedit1.Lines.Add(nachricht);
        end;
     end;
end;

procedure TclientForm.disconnectBitBtnClick(Sender: TObject);
begin
 clientsocket.close;
//clientsocket.active:=false;
NMStrm.Disconnect;
NMstrmserv.Disconnect;
end;

procedure TclientForm.sendenButtonClick(Sender: TObject);
begin
      ClientSocket.Socket.SendText('$#user:'+ bname + ':' + inttostr(farbe) + '#' + edit1.text);
end;

procedure TclientForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then
 begin
      sendenbutton.click;
      edit1.text:='';
  end;
end;

procedure TclientForm.connectBitBtnClick(Sender: TObject);
begin
 verbinden2.Click;
end;

procedure TclientForm.farbeBitBtnClick(Sender: TObject);
begin
 if clientform.ColorDialog1.Execute then farbe:=ColorDialog1.Color;
 edit1.font.color:=farbe;

end;

procedure TclientForm.FormCreate(Sender: TObject);
begin
 connectbitbtn.focused;
 FormList:=TObjectList.Create();
 FormList.OwnsObjects:=True;
end;

procedure TclientForm.FormShow(Sender: TObject);
begin
Connectbitbtn.SetFocus;
Randomize;
bname:='testname'+inttostr(Random(100));
server:='localhost';
verbunden:=false;
farbe:=clblack;
port:=5757;
suche:=false;
privatchats:=0;
end;

procedure TclientForm.exitBitBtnClick(Sender: TObject);
begin
clientform.Close;
end;

procedure TclientForm.ClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
if verbunden=true then    //wegen disconnect bei doppeltem benutzernamen
 begin
  ClientSocket.Socket.SendText('$#disconnect:'+ bname + '#');
  richedit1.Lines.add('Verbindung zum Chat getrennt');
 end;
  userlistbox.Clear;
  label3.caption:='kein Server gefunden';

end;

procedure TclientForm.ClientSocketConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
//  showmessage(inttostr(port));
  richedit1.lines.Add('Verbindung wird hergestellt...');
end;

procedure TclientForm.privatchatBitBtnClick(Sender: TObject);
 var   pmessage : string;
begin

 if not(userlistbox.itemindex=-1) then
  begin
    if InputQuery('Private Nachricht', 'Private Nachricht an ' + user[userlistbox.itemindex].name + ':', pmessage) then
       begin
            ClientSocket.Socket.SendText('$#pmessage:'+ user[userlistbox.itemindex].name + ':' + bname + '#' + pmessage);
            Richedit1.Lines.add('Private Nachricht an '+ user[userlistbox.itemindex].name + ': ' + pmessage);
       end;
  end
  else showmessage('Sie mssen einen User auswhlen, an den sie eine Private Nachricht schicken wollen!');
end;

procedure TclientForm.Farbe1Click(Sender: TObject);
begin
farbebitbtn.click;
end;

procedure TclientForm.Beenden1Click(Sender: TObject);
begin
exitbitbtn.click;
end;

procedure TclientForm.pchatBitBtnClick(Sender: TObject);
begin
 UserListBoxDblClick(Sender);
end;


procedure TclientForm.Suche1Click(Sender: TObject);
begin
 suchform.visible:=true;
// clientform.visible:=false;
end;

procedure TclientForm.Einstellungen1Click(Sender: TObject);
begin
 clientform.enabled:=false;
 einstellungsform.visible:=true;

end;

procedure TclientForm.flstern1Click(Sender: TObject);
begin
 privatchatbitbtn.click;
end;

procedure TclientForm.sentfileBitBtnClick(Sender: TObject);
begin
 if not(userlistbox.itemindex=-1) then
  begin
     Clientform.enabled:=false;
     sentfileform.visible:=true;
     sentfileform.edit1.text:=user[userlistbox.itemindex].name;
     sentfile:=userlistbox.itemindex;
  end
  else showmessage('Sie mssen einen User auswhlen, an den sie eine Datei schicken wollen!');
end;

procedure TclientForm.NMStrmConnect(Sender: TObject);
begin
richedit1.lines.add('Filesent connected');
end;

procedure TclientForm.NMStrmConnectionFailed(Sender: TObject);
begin
richedit1.lines.add('Filesent Connection Failed');
end;

procedure TclientForm.NMStrmMessageSent(Sender: TObject);
begin
richedit1.Lines.add('Files Sent');
end;

procedure TclientForm.NMStrmPacketSent(Sender: TObject);
begin
if not (NMStrm.BytesSent=NMStrm.BytesTotal) then
   begin
        label6.visible:=true;
        progressbar1.visible:=true;
        progressbar1.Max:=NMStrm.BytesTotal;
        progressbar1.position:=NMStrm.BytesSent;
   end else
   begin
        label6.visible:=false;
        progressbar1.visible:=false;
   end;
Richedit1.lines.add (inttostr(NMStrm.BytesSent)+' bytes '+' of '+IntToStr(NMStrm.BytesTotal)+' bytes '+' sent');
end;

procedure TclientForm.NMStrmServClientContact(Sender: TObject);
begin
NMStrmServ.ReportLevel := Status_Basic;
NMStrmServ.TimeOut := 90000;

end;

procedure TclientForm.NMStrmServMSG(Sender: TComponent;
  const sFrom: String; strm: TStream);
 var
  MyFStream: TFileStream;
  erhalten : string;
begin
  if SaveDialog1.Execute then
  begin
    erhalten:=savedialog1.FileName+ext;
    SaveDialog1.title:='Datei speichern';
    SaveDialog1.Filter:= '*.*';
//    showmessage('erweiterung' + label6.caption);
//       while not(pos('\' ,erhalten)=0) do erhalten:=copy(erhalten,pos('\', erhalten)+1,length(erhalten)-pos('\', erhalten));  //kopiert Dateinamen heraus
    MyFStream := TFileStream.Create(erhalten, fmCreate);

    try
      MyFStream.CopyFrom(strm, strm.size);
    finally
      MYFStream.Free;
    end;
    richedit1.SelAttributes.color:=clblue;
    richedit1.Lines.add('Datei erhalten');
  end;

end;

procedure TclientForm.NMStrmServConnect(Sender: TObject);
begin
    richedit1.SelAttributes.color:=clblue;
    richedit1.Lines.add('Erhalte Daten...');
end;

procedure TclientForm.UserListBoxDblClick(Sender: TObject);
begin
 if not(userlistbox.itemindex=-1) then
  begin
     privatchat(user[userlistbox.itemindex].name);
  end
  else showmessage('Sie mssen einen User auswhlen, mit dem sie einen Privatchat starten wollen!');
end;

procedure TclientForm.NMStrmServConnectionFailed(Sender: TObject);
begin
richedit1.lines.add('Serverfilereached Connection Failed');

end;

procedure TclientForm.Hilfe2Click(Sender: TObject);
begin
 clientform.enabled:=false;
 HilfeForm.visible:=true;
 HilfeForm.PageControl1.ActivePageIndex:=0;

end;

procedure TclientForm.Credits2Click(Sender: TObject);
begin
 clientform.enabled:=false;
 HilfeForm.visible:=true;
 HilfeForm.PageControl1.ActivePageIndex:=2;
end;

end.
