unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ScktComp, ComCtrls, contnrs, ExtCtrls;

type
  TsuchForm = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    serverListBox: TListBox;
    verbindenBitBtn: TBitBtn;
    suchstartBitBtn: TBitBtn;
    suchstopBitBtn: TBitBtn;
    ProgressBar1: TProgressBar;
    Label4: TLabel;
    Label5: TLabel;
    Timer1: TTimer;
    Label1: TLabel;
    procedure suchstartBitBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure suchstopBitBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure verbindenBitBtnClick(Sender: TObject);
    procedure serversuche (Sender : TObject; con : boolean);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure serverListBoxDblClick(Sender: TObject);

  private
    { Private-Deklarationen }
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);

  public
    { Public-Deklarationen }
  end;


var
  suchForm: TsuchForm;

TYPE
   T_server= RECORD
               ip                : string;
               name              : string;
               port              : integer;
             END;
   T_servers = Array[0..255] of T_server;


implementation

uses Unit2,Unit1,WinSock;

{$R *.DFM}

var
   server                   : T_servers;
   gefunden, zeit           : integer;
   clientsocketlist         : TObjectList;
   clientsocket             : array[1..255] of Tclientsocket;
   formschliessen           :boolean;

const
     clientanz = 255;

{--------------------------eigene Proceduren-----------------------}
function DNStoIP(ip : string) : String;
var 
   phoste : PHostEnt;
   WSAData : TWSADATA;
// $0101 ist zB. 257
begin
   if WSAStartup($0101, WSADATA) = 0 then begin
      phoste := GetHostByName(pchar(ip)); 
      if phoste = nil then 
         ip := 'Error' 
      else 
         ip := StrPas(inet_ntoa(PInAddr(phoste^.h_addr_list^)^)); 
      WSACleanup; 
   end; 
   result := ip; 
end;

function GetIP: string; 	
type PPInAddr = ^PInAddr; 	
var 	
  wsaData: TWSAData; 	
  HostInfo: PHostEnt; 	
  HostName: array[0..255] of Char; 	
  Addr: PPInAddr; 	
begin 	
  Result := ''; 	
  if WSAStartup($0102, wsaData) <> 0 then exit;
  try
    if gethostname(HostName, SizeOf(HostName)) <> 0 then exit;
    HostInfo := gethostbyname(HostName); 	
    if HostInfo = nil then Exit; 	
    Addr := Pointer(HostInfo^.h_addr_list); 	
    if (Addr = nil) or (Addr^ = nil) then exit;
    Result := StrPas(inet_ntoa(Addr^^)); 	
    inc(Addr); 	
    while Addr^ <> nil do  begin 	
      Result := Result + ^M^J+ StrPas(inet_ntoa(Addr^^)); 	
      inc(Addr); 	
    end; 	
  finally 	
    WSACleanup; 	
  end; 	
end;


procedure TsuchForm.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  if suche then suchform.serversuche(Sender as Tclientsocket, true);
end;

procedure TsuchForm.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ErrorCode:=0;
  if suche then suchform.serversuche(Sender as Tclientsocket, false);
end;

procedure TsuchForm.serversuche(Sender : TObject; con : boolean);
var i: integer;
begin
//showmessage('suchform');
  if Suche then
    begin

       if con=true then
       begin
         inc(gefunden);
         server[gefunden].name:=(Sender as Tclientsocket).Socket.RemoteHost;
         server[gefunden].ip:=(Sender as Tclientsocket).Socket.RemoteAddress;
         server[gefunden].port:=(Sender as Tclientsocket).port;
         serverlistbox.clear;
         for i:=0 to gefunden do suchform.serverListBox.Items.Add(server[i].name + ' ' + server[i].ip);
       end;

       if (ip4 < 255) then inc(ip4) else
        begin
           suche:=false;
//           progressbar1.position:=0;
//           showmessage('Suche beendet');
        end;

// showmessage('notcon');
  edit4.text:=inttostr(ip4);
  edit5.text:=inttostr(suchport);

  //showmessage(inttostr(clientsocket2.ComponentIndex));


  with (Sender as Tclientsocket) do
   begin
      close;
      Port :=suchport;
//      showmessage(inttostr(clientform.clientsocket.port));
//      showmessage(inttostr(ip1)+'.'+inttostr(ip2)+'.'+inttostr(ip3)+'.'+inttostr(ip4));
      Host := inttostr(ip1)+'.'+inttostr(ip2)+'.'+inttostr(ip3)+'.'+inttostr(ip4);
//      Showmessage(Host);
      try
          open;
      except
          showmessage('berprfung von Port ' + inttostr(suchport) + ' fehlgeschlagen');
      //  	on EZeroDivide do HandleZeroDivide;
      end;

   end;

    end;
end;
{
procedure TsuchForm.serversuche(nummer : integer; con : boolean);
var i: integer;
begin

  if Suche then
    begin

       if con=true then
       begin
         inc(gefunden);
         server[gefunden].name:=(suchform.Components[nummer] AS TClientSocket).Socket.RemoteHost;
         server[gefunden].ip:=(suchform.Components[nummer] AS TClientSocket).Socket.RemoteAddress;
         server[gefunden].port:=(suchform.Components[nummer] AS TClientSocket).port;
         serverlistbox.clear;
         for i:=0 to gefunden do suchform.serverListBox.Items.Add(server[i].name + ' ' + server[i].ip);
       end;

       if (ip4 < 254) then inc(ip4) else
        begin
           suche:=false;
           progressbar1.position:=0;
           showmessage('Suche beendet');
        end;

// showmessage('notcon');
  edit4.text:=inttostr(ip4);
  edit5.text:=inttostr(suchport);
  progressbar1.Position:=ip4;

  //showmessage(inttostr(clientsocket2.ComponentIndex));
  with (suchform.Components[nummer] AS TClientSocket) do
   begin
      close;
      Port :=suchport;
//      showmessage(inttostr(clientform.clientsocket.port));
//      showmessage(inttostr(ip1)+'.'+inttostr(ip2)+'.'+inttostr(ip3)+'.'+inttostr(ip4));
      Host := inttostr(ip1)+'.'+inttostr(ip2)+'.'+inttostr(ip3)+'.'+inttostr(ip4);
      open;
   end;

    end;
end;
}
{----------------------Ende eigener Proceduren---------------------}

procedure TsuchForm.suchstartBitBtnClick(Sender: TObject);
var i: integer;
begin
 if edit1.text='1' then ip4:=0 else ip4:=strtoint(edit4.text);
 suche:=true;
 timer1.enabled:=true;
 zeit:=0;
 serverlistbox.clear;
 progressbar1.position:=0;
 suchstartbitbtn.enabled:=false;
 suchport:=strtoint(edit5.text);
 ip1:=strtoint(edit1.text);
 if not ((ip1 > 0) and  (ip1 < 256)) then ip1:=192;
 ip2:=strtoint(edit2.text);
 if not ((ip2 > 0) and  (ip2 < 256)) then ip2:=168;
 ip3:=strtoint(edit3.text);
 if not ((ip3 > 0) and  (ip3 < 256)) then ip3:=0;
 edit1.text:=inttostr(ip1);
 edit2.text:=inttostr(ip2);
 edit3.text:=inttostr(ip3);
 ip4:=0;

// i:=1;
 for i:=1 to clientanz do begin
     clientsocket[i]:=Tclientsocket.create(suchForm);
//     clientsocket[i].parent:=TsuchForm;
     clientsocket[i].OnConnect:=ClientSocketConnect;
     clientsocket[i].OnError:=ClientSocketError;
     clientsocketlist.add(clientsocket[i]);
     serversuche(clientsocket[i],false);
 end;
 {
 serversuche(clientsocket2.ComponentIndex,false);
 serversuche(clientsocket3.ComponentIndex,false);
 serversuche(clientsocket4.ComponentIndex,false);
 serversuche(clientsocket5.ComponentIndex,false);
 serversuche(clientsocket6.ComponentIndex,false);
 serversuche(clientsocket7.ComponentIndex,false);
 serversuche(clientsocket8.ComponentIndex,false);
 serversuche(clientsocket9.ComponentIndex,false);
 serversuche(clientsocket10.ComponentIndex,false);
 serversuche(clientsocket11.ComponentIndex,false);
 }
end;

procedure TsuchForm.FormShow(Sender: TObject);
var ip,temp: string;
begin
//     showmessage(IPadress('md'));
//     showmessage(GetIP);

     ip1:=192;
     ip2:=168;
     ip3:=0;
     ip4:=1;

     ip:=GetIP;
     if not(ip='') then
     begin
          ip1:=strtoint(copy(ip,0,pos('.',ip)-1));
          ip:=copy(ip,pos('.',ip)+1,length(ip));
          ip2:=strtoint(copy(ip,0,pos('.',ip)-1));
          ip:=copy(ip,pos('.',ip)+1,length(ip));
          ip3:=strtoint(copy(ip,0,pos('.',ip)-1));
     end;

     clientsocketlist:=TObjectList.Create();
     clientsocketlist.OwnsObjects:=True;
     serverlistbox.Clear;
     formschliessen:=false;

     suchport:=port;
     suche:=false;
     gefunden:=-1;

     edit1.text:=inttostr(ip1);
     edit2.text:=inttostr(ip2);
     edit3.text:=inttostr(ip3);
     edit4.text:=inttostr(ip4);
     edit5.text:=inttostr(port);

end;

procedure TsuchForm.suchstopBitBtnClick(Sender: TObject);
var i: integer;
begin
 timer1.enabled:=false;
 progressbar1.position:=0;
 progressbar1.position:=0;
 if not formschliessen then showmessage('Suche wurde beendet');
 suchstartbitbtn.enabled:=true;
 if suche then for i:=1 to clientanz do
               begin
                    clientsocket[i].close;
                    clientsocketlist.Remove(clientsocket[i]);
               end;
 suche:=false;
end;

procedure TsuchForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
formschliessen:=true;
suchstopbitbtn.click;
end;

procedure TsuchForm.verbindenBitBtnClick(Sender: TObject);
var  verbindung : string;
begin
 if not(serverlistbox.itemindex=-1) then
  begin
  clientform.ClientSocket.close;
  verbindung:=server[serverlistbox.itemindex].ip;
     if InputQuery('Benutername', 'Benutername (Max. 14 Zeichen):', bname) then
      if length(bname) > 0 then
      begin
           bname:=copy(bname,0,14);  // Benutzername darf nur 14 Zeichenhaben
           clientform.label5.caption:=bname;
           clientform.ClientSocket.Port :=port; // es ist nicht mglich mit with clientsocket do zu arbeiten, da variable auch port heit
           clientform.ClientSocket.Host := verbindung;
           clientform.Clientsocket.open;
           suchform.close;
      end;
  end
  else showmessage('Sie mssen einen server auswhlen, zu dem Sie verbunden werden wollen');
  
end;

procedure TsuchForm.Button1Click(Sender: TObject);
var i: integer;
begin

end;

procedure TsuchForm.Timer1Timer(Sender: TObject);
var i: integer;
begin
 inc(zeit);
  progressbar1.Position:=zeit;
  label1.caption:=inttostr(zeit) + ' Sek.';
  if zeit=30 then
  begin
       timer1.enabled:=false;
           for i:=1 to clientanz do
           // kann objekt 21 (das die ip findet) nicht lschen
           clientsocket[i].close;
           clientsocketlist.Remove(clientsocket[i]);
           progressbar1.position:=0;
           showmessage('Suche beendet');
           suchstartbitbtn.enabled:=true;
  end;
end;

procedure TsuchForm.serverListBoxDblClick(Sender: TObject);
begin
     verbindenbitbtn.Click;
end;

end.
